--------------------------------------------------------------------------------
-- Tooltip                                                                    --
--------------------------------------------------------------------------------
local _, me = ...                                 --Includes all functions and variables

--(All credit for this func goes to Tekkub and his picoGuild!)
function me:GetTipAnchor(frame)                   --although used with dropdownmenu
  local x, y = frame:GetCenter()
  if not x or not y then return 'TOPLEFT', 'BOTTOMLEFT' end
  local hhalf = (x > UIParent:GetWidth() * 2 / 3) and 'RIGHT' or (x < UIParent:GetWidth() / 3) and 'LEFT' or ''
  local vhalf = (y > UIParent:GetHeight() / 2) and 'TOP' or 'BOTTOM'
  return vhalf..hhalf, frame, (vhalf == 'TOP' and 'BOTTOM' or 'TOP')..hhalf
end

--Main Tooltip
function me:tooltip(self)
  GameTooltip:SetOwner(self, "ANCHOR_NONE")
  GameTooltip:SetPoint(me:GetTipAnchor(self))
  GameTooltip:ClearLines()
  GameTooltip:AddLine(me.L["professions"].." (Broker_ProfessionsMenu)")
  --Main Professions
  if (me.save.config.showprimary == true) then
   GameTooltip:AddLine(" ")
   GameTooltip:AddLine(me.L["primary"])
   for k,v in me:pairsByKeys(me:FilterProfs(me.P.Primary)) do
    GameTooltip:AddDoubleLine(k,v["rank"].."/"..v["maxrank"],1,1,1,0,1,0)
   end
  end
  --Secondary Skills
  if (me.save.config.showsecondary == true) then
   GameTooltip:AddLine(" ")
   GameTooltip:AddLine(me.L["secondary"])
   for k,v in me:pairsByKeys(me:FilterProfs(me.P.Secondary)) do
    GameTooltip:AddDoubleLine(k,v["rank"].."/"..v["maxrank"],1,1,1,0,1,0)
    if (v["cd"]~=nil and me.save.config.showcds) then
     for kk,vv in me:pairsByKeys(v["cd"]) do
      GameTooltip:AddDoubleLine("->"..kk,me:GetCD(vv),1,1,1,0,1,0)
     end
    end
   end
  end
  --Cooldowns
  if (me.save.config.showcds == true) then
   local jj = nil
   local duration = 0
   GameTooltip:AddLine(" ")
   GameTooltip:AddLine(me.L["cds"])
   for k,v in me:pairsByKeys(me.save.cds) do
    duration = difftime(v,time())
    if duration>0 then
     jj=true
     GameTooltip:AddDoubleLine(k,me:formatduration(duration),1,1,1,1,0,0)
    end
   end
   for k,v in me:pairsByKeys(me.saveallchars) do
    if k~=UnitName("player") and v.faction==UnitFactionGroup("player") and v.cds~=nil then
     for kk,vv in me:pairsByKeys(v.cds) do
      duration = difftime(vv,time())
      if duration>0 then
       jj=true
       GameTooltip:AddDoubleLine("["..k.."] "..kk,me:formatduration(duration),1,1,1,1,0,0)
      end
     end
    end
   end
   if not jj then
    GameTooltip:AddLine(me.L["nocds"],0,1,0)
   end
  end 
  --Weapon Skills
  if (me.save.config.showother == true) then
   GameTooltip:AddLine(" ")
   GameTooltip:AddLine(me.L["weapon"])
   for k,v in me:pairsByKeys(me:GetWeaponSkills()) do
    GameTooltip:AddDoubleLine(k,v["rank"].."/"..v["maxrank"],1,1,1,0,1,0)
   end
  end
  --Infos
  GameTooltip:AddLine(" ")
  GameTooltip:AddLine(me.L["leftclick"]..": |cffffffff"..me.save.default.left.."|r")
  GameTooltip:AddLine(me.L["shiftleftclick"]..": |cffffffff"..me.save.default.shiftleft.."|r")
  GameTooltip:AddLine(me.L["altleftclick"]..": |cffffffff"..me.save.default.altleft.."|r")
  GameTooltip:AddLine(me.L["ctrlleftclick"]..": |cffffffff"..me.save.default.ctrlleft.."|r")
  GameTooltip:AddLine(me.L["rightclick"])
end


--Moveable Tooltip
function me:moveabletooltip(self)
  GameTooltip:SetOwner(self, "ANCHOR_NONE")
  GameTooltip:SetPoint(me:GetTipAnchor(self))
  GameTooltip:ClearLines()
  GameTooltip:AddLine(me.L["lock"])
end


--Quicklauncher Tooltip
function me:quicklaunchertooltip(self,spell)
  GameTooltip:SetOwner(self, "ANCHOR_NONE")
  GameTooltip:SetPoint(me:GetTipAnchor(self))
  GameTooltip:ClearLines()
  GameTooltip:AddLine(spell)
end